iCalendar-0.4.0.3: iCalendar data types, parser, and printer.

Safe Haskell | None
Language | Haskell98

Text.ICalendar.Types

Description

ICalendar types, based on RFC5545.

Synopsis

- newtype Language = Language (CI Text)
- type CalAddress = URI
- data OtherParam = OtherParam (CI Text) [Text]
- data OtherParams = OtherParams (Set OtherParam)
- data VCalendar = VCalendar {
  - vcProdId :: ProdId
  - vcVersion :: ICalVersion
  - vcScale :: Scale
  - vcMethod :: Maybe Method
  - vcOther :: Set OtherProperty
  - vcTimeZones :: Map Text VTimeZone
  - vcEvents :: Map (Text, Maybe (Either Date DateTime)) VEvent
  - vcTodos :: Map (Text, Maybe (Either Date DateTime)) VTodo
  - vcJournals :: Map (Text, Maybe (Either Date DateTime)) VJournal
  - vcFreeBusys :: Map Text VFreeBusy
  - vcOtherComps :: Set VOther
  }
- data ProdId = ProdId {
  - prodIdValue :: Text
  - prodIdOther :: OtherParams
  }
- data ICalVersion
  - = MaxICalVersion {
    - versionMax :: Version
    - versionOther :: OtherParams
    }
  - | MinMaxICalVersion {
    - versionMax :: Version
    - versionMin :: Version
    - versionOther :: OtherParams
    }
- data Scale = Scale {
  - scaleValue :: CI Text
  - scaleOther :: OtherParams
  }
- data Method = Method {
  - methodValue :: CI Text
  - methodOther :: OtherParams
  }
- data VEvent = VEvent {
  - veDTStamp :: DTStamp
  - veUID :: UID
  - veClass :: Class
  - veDTStart :: Maybe DTStart
  - veCreated :: Maybe Created
  - veDescription :: Maybe Description
  - veGeo :: Maybe Geo
  - veLastMod :: Maybe LastModified
  - veLocation :: Maybe Location
  - veOrganizer :: Maybe Organizer
  - vePriority :: Priority
  - veSeq :: Sequence
  - veStatus :: Maybe EventStatus
  - veSummary :: Maybe Summary
  - veTransp :: TimeTransparency
  - veUrl :: Maybe URL
  - veRecurId :: Maybe RecurrenceId
  - veRRule :: Set RRule
  - veDTEndDuration :: Maybe (Either DTEnd DurationProp)
  - veAttach :: Set Attachment
  - veAttendee :: Set Attendee
  - veCategories :: Set Categories
  - veComment :: Set Comment
  - veContact :: Set Contact
  - veExDate :: Set ExDate
  - veRStatus :: Set RequestStatus
  - veRelated :: Set RelatedTo
  - veResources :: Set Resources
  - veRDate :: Set RDate
  - veAlarms :: Set VAlarm
  - veOther :: Set OtherProperty
  }
- data VTodo = VTodo {
  - vtDTStamp :: DTStamp
  - vtUID :: UID
  - vtClass :: Class
  - vtCompleted :: Maybe Completed
  - vtCreated :: Maybe Created
  - vtDescription :: Maybe Description
  - vtDTStart :: Maybe DTStart
  - vtGeo :: Maybe Geo
  - vtLastMod :: Maybe LastModified
  - vtLocation :: Maybe Location
  - vtOrganizer :: Maybe Organizer
  - vtPercent :: Maybe PercentComplete
  - vtPriority :: Priority
  - vtRecurId :: Maybe RecurrenceId
  - vtSeq :: Sequence
  - vtStatus :: Maybe TodoStatus
  - vtSummary :: Maybe Summary
  - vtUrl :: Maybe URL
  - vtRRule :: Set RRule
  - vtDueDuration :: Maybe (Either Due DurationProp)
  - vtAttach :: Set Attachment
  - vtAttendee :: Set Attendee
  - vtCategories :: Set Categories
  - vtComment :: Set Comment
  - vtContact :: Set Contact
  - vtExDate :: Set ExDate
  - vtRStatus :: Set RequestStatus
  - vtRelated :: Set RelatedTo
  - vtResources :: Set Resources
  - vtRDate :: Set RDate
  - vtAlarms :: Set VAlarm
  - vtOther :: Set OtherProperty
  }
- data VJournal = VJournal {
  - vjDTStamp :: DTStamp
  - vjUID :: UID
  - vjClass :: Class
  - vjCreated :: Maybe Created
  - vjDTStart :: Maybe DTStart
  - vjLastMod :: Maybe LastModified
  - vjOrganizer :: Maybe Organizer
  - vjRecurId :: Maybe RecurrenceId
  - vjSeq :: Sequence
  - vjStatus :: Maybe JournalStatus
  - vjSummary :: Maybe Summary
  - vjUrl :: Maybe URL
  - vjRRule :: Set RRule
  - vjAttach :: Set Attachment
  - vjAttendee :: Set Attendee
  - vjCategories :: Set Categories
  - vjComment :: Set Comment
  - vjContact :: Set Contact
  - vjDescription :: Set Description
  - vjExDate :: Set ExDate
  - vjRelated :: Set RelatedTo
  - vjRDate :: Set RDate
  - vjRStatus :: Set RequestStatus
  - vjOther :: Set OtherProperty
  }
- data VFreeBusy = VFreeBusy {
  - vfbDTStamp :: DTStamp
  - vfbUID :: UID
  - vfbContact :: Maybe Contact
  - vfbDTStart :: Maybe DTStart
  - vfbDTEnd :: Maybe DTEnd
  - vfbOrganizer :: Maybe Organizer
  - vfbUrl :: Maybe URL
  - vfbAttendee :: Set Attendee
  - vfbComment :: Set Comment
  - vfbFreeBusy :: Set FreeBusy
  - vfbRStatus :: Set RequestStatus
  - vfbOther :: Set OtherProperty
  }
- data VTimeZone = VTimeZone {
  - vtzId :: TZID
  - vtzLastMod :: Maybe LastModified
  - vtzUrl :: Maybe TZUrl
  - vtzStandardC :: Set TZProp
  - vtzDaylightC :: Set TZProp
  - vtzOther :: Set OtherProperty
  }
- data TZProp = TZProp {
  - tzpDTStart :: DTStart
  - tzpTZOffsetTo :: UTCOffset
  - tzpTZOffsetFrom :: UTCOffset
  - tzpRRule :: Set RRule
  - tzpComment :: Set Comment
  - tzpRDate :: Set RDate
  - tzpTZName :: Set TZName
  - tzpOther :: Set OtherProperty
  }
- data VAlarm
  - = VAlarmAudio {
    - vaTrigger :: Trigger
    - vaRepeat :: Repeat
    - vaDuration :: Maybe DurationProp
    - vaAudioAttach :: Maybe Attachment
    - vaOther :: Set OtherProperty
    - vaActionOther :: OtherParams
    }
  - | VAlarmDisplay {
    - vaDescription :: Description
    - vaTrigger :: Trigger
    - vaRepeat :: Repeat
    - vaDuration :: Maybe DurationProp
    - vaOther :: Set OtherProperty
    - vaActionOther :: OtherParams
    }
  - | VAlarmEmail {
    - vaDescription :: Description
    - vaTrigger :: Trigger
    - vaSummary :: Summary
    - vaAttendee :: Set Attendee
    - vaRepeat :: Repeat
    - vaDuration :: Maybe DurationProp
    - vaMailAttach :: Set Attachment
    - vaOther :: Set OtherProperty
    - vaActionOther :: OtherParams
    }
  - | VAlarmX {
    - vaAction :: CI Text
    - vaTrigger :: Trigger
    - vaActionOther :: OtherParams
    - vaOther :: Set OtherProperty
    }
- data VOther = VOther {
  - voName :: CI Text
  - voProps :: Set OtherProperty
  }
- data Attachment
  - = UriAttachment {
    - attachFmtType :: Maybe MIMEType
    - attachUri :: URI
    - attachOther :: OtherParams
    }
  - | BinaryAttachment {
    - attachFmtType :: Maybe MIMEType
    - attachContent :: ByteString
    - attachOther :: OtherParams
    }
- data Categories = Categories {
  - categoriesValues :: Set Text
  - categoriesLanguage :: Maybe Language
  - categoriesOther :: OtherParams
  }
- data Class = Class {
  - classValue :: ClassValue
  - classOther :: OtherParams
  }
- data ClassValue
  - = Public
  - | Private
  - | Confidential
  - | ClassValueX (CI Text)
- data Completed = Completed {
  - completedValue :: DateTime
  - completedOther :: OtherParams
  }
- data Comment = Comment {
  - commentValue :: Text
  - commentAltRep :: Maybe URI
  - commentLanguage :: Maybe Language
  - commentOther :: OtherParams
  }
- data Description = Description {
  - descriptionValue :: Text
  - descriptionAltRep :: Maybe URI
  - descriptionLanguage :: Maybe Language
  - descriptionOther :: OtherParams
  }
- data Geo = Geo {
  - geoLat :: Float
  - geoLong :: Float
  - geoOther :: OtherParams
  }
- data Location = Location {
  - locationValue :: Text
  - locationAltRep :: Maybe URI
  - locationLanguage :: Maybe Language
  - locationOther :: OtherParams
  }
- data PercentComplete = PercentComplete {
  - percentCompleteValue :: Int
  - percentCompleteOther :: OtherParams
  }
- data Priority = Priority {
  - priorityValue :: Int
  - priorityOther :: OtherParams
  }
- data Resources = Resources {
  - resourcesValue :: Set Text
  - resourcesAltRep :: Maybe URI
  - resourcesLanguage :: Maybe Language
  - resourcesOther :: OtherParams
  }
- data EventStatus
  - = TentativeEvent {
    - eventStatusOther :: OtherParams
    }
  - | ConfirmedEvent {
    - eventStatusOther :: OtherParams
    }
  - | CancelledEvent {
    - eventStatusOther :: OtherParams
    }
- data TodoStatus
  - = TodoNeedsAction {
    - todoStatusOther :: OtherParams
    }
  - | CompletedTodo {
    - todoStatusOther :: OtherParams
    }
  - | InProcessTodo {
    - todoStatusOther :: OtherParams
    }
  - | CancelledTodo {
    - todoStatusOther :: OtherParams
    }
- data JournalStatus
  - = DraftJournal {
    - journalStatusOther :: OtherParams
    }
  - | FinalJournal {
    - journalStatusOther :: OtherParams
    }
  - | CancelledJournal {
    - journalStatusOther :: OtherParams
    }
- data Summary = Summary {
  - summaryValue :: Text
  - summaryAltRep :: Maybe URI
  - summaryLanguage :: Maybe Language
  - summaryOther :: OtherParams
  }
- data Date = Date {
  - dateValue :: Day
  }
- data DateTime
  - = FloatingDateTime {
    - dateTimeFloating :: LocalTime
    }
  - | UTCDateTime {
    - dateTimeUTC :: UTCTime
    }
  - | ZonedDateTime {
    - dateTimeFloating :: LocalTime
    - dateTimeZone :: Text
    }
- data DTEnd
  - = DTEndDateTime {
    - dtEndDateTimeValue :: DateTime
    - dtEndOther :: OtherParams
    }
  - | DTEndDate {
    - dtEndDateValue :: Date
    - dtEndOther :: OtherParams
    }
- data Due
  - = DueDateTime {
    - dueDateTimeValue :: DateTime
    - dueOther :: OtherParams
    }
  - | DueDate {
    - dueDateValue :: Date
    - dueOther :: OtherParams
    }
- data DTStart
  - = DTStartDateTime {
    - dtStartDateTimeValue :: DateTime
    - dtStartOther :: OtherParams
    }
  - | DTStartDate {
    - dtStartDateValue :: Date
    - dtStartOther :: OtherParams
    }
- data Duration
  - = DurationDate {
    - durSign :: Sign
    - durDay :: Int
    - durHour :: Int
    - durMinute :: Int
    - durSecond :: Int
    }
  - | DurationTime {
    - durSign :: Sign
    - durHour :: Int
    - durMinute :: Int
    - durSecond :: Int
    }
  - | DurationWeek {
    - durSign :: Sign
    - durWeek :: Int
    }
- data Sign
  - = Positive
  - | Negative
- data DurationProp = DurationProp {
  - durationValue :: Duration
  - durationOther :: OtherParams
  }
- data FreeBusy = FreeBusy {
  - freeBusyType :: FBType
  - freeBusyPeriods :: Set UTCPeriod
  - freeBusyOther :: OtherParams
  }
- data Period
  - = PeriodDates DateTime DateTime
  - | PeriodDuration DateTime Duration
- data UTCPeriod
  - = UTCPeriodDates UTCTime UTCTime
  - | UTCPeriodDuration UTCTime Duration
- data FBType
  - = Free
  - | Busy
  - | BusyUnavailable
  - | BusyTentative
  - | FBTypeX (CI Text)
- data TimeTransparency
  - = Opaque {
    - timeTransparencyOther :: OtherParams
    }
  - | Transparent {
    - timeTransparencyOther :: OtherParams
    }
- data TZID = TZID {
  - tzidValue :: Text
  - tzidGlobal :: Bool
  - tzidOther :: OtherParams
  }
- data TZName = TZName {
  - tzNameValue :: Text
  - tzNameLanguage :: Maybe Language
  - tzNameOther :: OtherParams
  }
- data UTCOffset = UTCOffset {
  - utcOffsetValue :: Int
  - utcOffsetOther :: OtherParams
  }
- data TZUrl = TZUrl {
  - tzUrlValue :: URI
  - tzUrlOther :: OtherParams
  }
- data Attendee = Attendee {
  - attendeeValue :: CalAddress
  - attendeeCUType :: CUType
  - attendeeMember :: Set CalAddress
  - attendeeRole :: Role
  - attendeePartStat :: PartStat
  - attendeeRSVP :: Bool
  - attendeeDelTo :: Set CalAddress
  - attendeeDelFrom :: Set CalAddress
  - attendeeSentBy :: Maybe CalAddress
  - attendeeCN :: Maybe Text
  - attendeeDir :: Maybe URI
  - attendeeLanguage :: Maybe Language
  - attendeeOther :: OtherParams
  }
- data CUType
  - = Individual
  - | Group
  - | Resource
  - | Room
  - | Unknown
  - | CUTypeX (CI Text)
- data Role
  - = Chair
  - | ReqParticipant
  - | OptParticipant
  - | NonParticipant
  - | RoleX (CI Text)
- data PartStat
  - = PartStatNeedsAction
  - | Accepted
  - | Declined
  - | Tentative
  - | Delegated
  - | PartStatCompleted
  - | InProcess
  - | PartStatX (CI Text)
- data Contact = Contact {
  - contactValue :: Text
  - contactAltRep :: Maybe URI
  - contactLanguage :: Maybe Language
  - contactOther :: OtherParams
  }
- data Organizer = Organizer {
  - organizerValue :: CalAddress
  - organizerCN :: Maybe Text
  - organizerDir :: Maybe URI
  - organizerSentBy :: Maybe CalAddress
  - organizerLanguage :: Maybe Language
  - organizerOther :: OtherParams
  }
- data RecurrenceId
  - = RecurrenceIdDate {
    - recurrenceIdDate :: Date
    - recurrenceIdRange :: Maybe Range
    - recurrenceIdOther :: OtherParams
    }
  - | RecurrenceIdDateTime {
    - recurrenceIdDateTime :: DateTime
    - recurrenceIdRange :: Maybe Range
    - recurrenceIdOther :: OtherParams
    }
- data Range
  - = ThisAndFuture
  - | ThisAndPrior
- data RelatedTo = RelatedTo {
  - relatedToValue :: Text
  - relatedToType :: RelationshipType
  - relatedToOther :: OtherParams
  }
- data RelationshipType
  - = Parent
  - | Child
  - | Sibling
  - | RelationshipTypeX (CI Text)
- data URL = URL {
  - urlValue :: URI
  - urlOther :: OtherParams
  }
- data UID = UID {
  - uidValue :: Text
  - uidOther :: OtherParams
  }
- data ExDate
  - = ExDates {
    - exDates :: Set Date
    - exDateOther :: OtherParams
    }
  - | ExDateTimes {
    - exDateTimes :: Set DateTime
    - exDateOther :: OtherParams
    }
- data RDate
  - = RDateDates {
    - rDateDates :: Set Date
    - rDateOther :: OtherParams
    }
  - | RDateDateTimes {
    - rDateDateTimes :: Set DateTime
    - rDateOther :: OtherParams
    }
  - | RDatePeriods {
    - rDatePeriods :: Set Period
    - rDateOther :: OtherParams
    }
- data Frequency
  - = Secondly
  - | Minutely
  - | Hourly
  - | Daily
  - | Weekly
  - | Monthly
  - | Yearly
- data Weekday
  - = Sunday
  - | Monday
  - | Tuesday
  - | Wednesday
  - | Thursday
  - | Friday
  - | Saturday
- data Recur = Recur {
  - recurFreq :: Frequency
  - recurUntilCount :: Maybe (Either (Either Date DateTime) Int)
  - recurInterval :: Int
  - recurBySecond :: [Int]
  - recurByMinute :: [Int]
  - recurByHour :: [Int]
  - recurByDay :: [Either (Int, Weekday) Weekday]
  - recurByMonthDay :: [Int]
  - recurByYearDay :: [Int]
  - recurByWeekNo :: [Int]
  - recurByMonth :: [Int]
  - recurBySetPos :: [Int]
  - recurWkSt :: Weekday
  }
- data RRule = RRule {
  - rRuleValue :: Recur
  - rRuleOther :: OtherParams
  }
- data Repeat = Repeat {
  - repeatValue :: Integer
  - repeatOther :: OtherParams
  }
- data AlarmTriggerRelationship
  - = Start
  - | End
- data Trigger
  - = TriggerDuration {
    - triggerDuration :: Duration
    - triggerRelated :: AlarmTriggerRelationship
    - triggerOther :: OtherParams
    }
  - | TriggerDateTime {
    - triggerDateTime :: UTCTime
    - triggerOther :: OtherParams
    }
- data Created = Created {
  - createdValue :: UTCTime
  - createdOther :: OtherParams
  }
- data DTStamp = DTStamp {
  - dtStampValue :: UTCTime
  - dtStampOther :: OtherParams
  }
- data LastModified = LastModified {
  - lastModifiedValue :: UTCTime
  - lastModifiedOther :: OtherParams
  }
- data Sequence = Sequence {
  - sequenceValue :: Integer
  - sequenceOther :: OtherParams
  }
- data RequestStatus = RequestStatus {
  - requestStatusCode :: [Int]
  - requestStatusDesc :: Text
  - requestStatusLanguage :: Maybe Language
  - requestStatusExt :: Maybe Text
  - requestStatusOther :: OtherParams
  }
- data OtherProperty = OtherProperty {
  - otherName :: CI Text
  - otherValue :: ByteString
  - otherParams :: OtherParams
  }

# Documentation

newtype Language Source #

Language.

Constructors

Language (CI Text) |

Instances

Eq Language Source # |
Methods (==) :: Language -> Language -> Bool # (/=) :: Language -> Language -> Bool #
Ord Language Source # |
Methods compare :: Language -> Language -> Ordering # (<) :: Language -> Language -> Bool # (<=) :: Language -> Language -> Bool # (>) :: Language -> Language -> Bool # (>=) :: Language -> Language -> Bool # max :: Language -> Language -> Language # min :: Language -> Language -> Language #
Show Language Source # |
Methods showsPrec :: Int -> Language -> ShowS # show :: Language -> String # showList :: [Language] -> ShowS #

type CalAddress = URI Source #

data OtherParam Source #

One other parameter, either x-param or iana-param.

Constructors

OtherParam (CI Text) [Text] |

Instances

Eq OtherParam Source # |
Methods (==) :: OtherParam -> OtherParam -> Bool # (/=) :: OtherParam -> OtherParam -> Bool #
Ord OtherParam Source # |
Methods compare :: OtherParam -> OtherParam -> Ordering # (<) :: OtherParam -> OtherParam -> Bool # (<=) :: OtherParam -> OtherParam -> Bool # (>) :: OtherParam -> OtherParam -> Bool # (>=) :: OtherParam -> OtherParam -> Bool # max :: OtherParam -> OtherParam -> OtherParam # min :: OtherParam -> OtherParam -> OtherParam #
Show OtherParam Source # |
Methods showsPrec :: Int -> OtherParam -> ShowS # show :: OtherParam -> String # showList :: [OtherParam] -> ShowS #

data OtherParams Source #

Other parameters, either x-param or other iana-param.

Constructors

OtherParams (Set OtherParam) |

Instances

Eq OtherParams Source # |
Methods (==) :: OtherParams -> OtherParams -> Bool # (/=) :: OtherParams -> OtherParams -> Bool #
Ord OtherParams Source # |
Methods compare :: OtherParams -> OtherParams -> Ordering # (<) :: OtherParams -> OtherParams -> Bool # (<=) :: OtherParams -> OtherParams -> Bool # (>) :: OtherParams -> OtherParams -> Bool # (>=) :: OtherParams -> OtherParams -> Bool # max :: OtherParams -> OtherParams -> OtherParams # min :: OtherParams -> OtherParams -> OtherParams #
Show OtherParams Source # |
Methods showsPrec :: Int -> OtherParams -> ShowS # show :: OtherParams -> String # showList :: [OtherParams] -> ShowS #
Default OtherParams Source # |
Methods def :: OtherParams #

data VCalendar Source #

VCalendar component. 3.4.

Constructors

VCalendar |

Fields

- vcProdId :: ProdId
- vcVersion :: ICalVersion
- vcScale :: Scale
- vcMethod :: Maybe Method
- vcOther :: Set OtherProperty
- vcTimeZones :: Map Text VTimeZone

  Map TZID-value VTimeZone

- vcEvents :: Map (Text, Maybe (Either Date DateTime)) VEvent

  Map (UID-value, Maybe RecurrenceID-value) VEvent

- vcTodos :: Map (Text, Maybe (Either Date DateTime)) VTodo

  Map (UID-value, Maybe RecurrenceID-value) VTodo

- vcJournals :: Map (Text, Maybe (Either Date DateTime)) VJournal

  Map (UID-value, Maybe RecurrenceID-value) VJournal

- vcFreeBusys :: Map Text VFreeBusy

  Map UID-value VFreeBusy

- vcOtherComps :: Set VOther

Instances

Eq VCalendar Source # |
Methods (==) :: VCalendar -> VCalendar -> Bool # (/=) :: VCalendar -> VCalendar -> Bool #
Ord VCalendar Source # |
Methods compare :: VCalendar -> VCalendar -> Ordering # (<) :: VCalendar -> VCalendar -> Bool # (<=) :: VCalendar -> VCalendar -> Bool # (>) :: VCalendar -> VCalendar -> Bool # (>=) :: VCalendar -> VCalendar -> Bool # max :: VCalendar -> VCalendar -> VCalendar # min :: VCalendar -> VCalendar -> VCalendar #
Show VCalendar Source # |
Methods showsPrec :: Int -> VCalendar -> ShowS # show :: VCalendar -> String # showList :: [VCalendar] -> ShowS #
Monoid VCalendar Source # | `vcMethod` is ignored at the moment. Picks the left in most cases. On UIDRecurrenceIdTZID clash, picks the `VEvent`s, `VTodo`s and `VJournal`s with the highest (`Sequence`, `DTStamp`), the `VTimeZone`s with the highest `LastModified`, and `VFreeBusy` with the highest `DTStamp`. If the Sequence, DTStamp or LastModified is the same, picks the left.
Methods mempty :: VCalendar # mappend :: VCalendar -> VCalendar -> VCalendar # mconcat :: [VCalendar] -> VCalendar #
Default VCalendar Source # |
Methods def :: VCalendar #

data ProdId Source #

Product Identifier. 3.7.3.

Constructors

ProdId |

Fields

- prodIdValue :: Text
- prodIdOther :: OtherParams

Instances

Eq ProdId Source # |
Methods (==) :: ProdId -> ProdId -> Bool # (/=) :: ProdId -> ProdId -> Bool #
Ord ProdId Source # |
Methods compare :: ProdId -> ProdId -> Ordering # (<) :: ProdId -> ProdId -> Bool # (<=) :: ProdId -> ProdId -> Bool # (>) :: ProdId -> ProdId -> Bool # (>=) :: ProdId -> ProdId -> Bool # max :: ProdId -> ProdId -> ProdId # min :: ProdId -> ProdId -> ProdId #
Show ProdId Source # |
Methods showsPrec :: Int -> ProdId -> ShowS # show :: ProdId -> String # showList :: [ProdId] -> ShowS #

data ICalVersion Source #

Version. 3.7.4.

Constructors

MaxICalVersion |

Fields

- versionMax :: Version
- versionOther :: OtherParams

MinMaxICalVersion |

Fields

- versionMax :: Version
- versionMin :: Version
- versionOther :: OtherParams

Instances

Eq ICalVersion Source # |
Methods (==) :: ICalVersion -> ICalVersion -> Bool # (/=) :: ICalVersion -> ICalVersion -> Bool #
Ord ICalVersion Source # |
Methods compare :: ICalVersion -> ICalVersion -> Ordering # (<) :: ICalVersion -> ICalVersion -> Bool # (<=) :: ICalVersion -> ICalVersion -> Bool # (>) :: ICalVersion -> ICalVersion -> Bool # (>=) :: ICalVersion -> ICalVersion -> Bool # max :: ICalVersion -> ICalVersion -> ICalVersion # min :: ICalVersion -> ICalVersion -> ICalVersion #
Show ICalVersion Source # |
Methods showsPrec :: Int -> ICalVersion -> ShowS # show :: ICalVersion -> String # showList :: [ICalVersion] -> ShowS #

data Scale Source #

Calendar Scale. 3.7.1.

Constructors

Scale |

Fields

- scaleValue :: CI Text
- scaleOther :: OtherParams

Instances

Eq Scale Source # |
Methods (==) :: Scale -> Scale -> Bool # (/=) :: Scale -> Scale -> Bool #
Ord Scale Source # |
Methods compare :: Scale -> Scale -> Ordering # (<) :: Scale -> Scale -> Bool # (<=) :: Scale -> Scale -> Bool # (>) :: Scale -> Scale -> Bool # (>=) :: Scale -> Scale -> Bool # max :: Scale -> Scale -> Scale # min :: Scale -> Scale -> Scale #
Show Scale Source # |
Methods showsPrec :: Int -> Scale -> ShowS # show :: Scale -> String # showList :: [Scale] -> ShowS #
Default Scale Source # |
Methods def :: Scale #

data Method Source #

Method. 3.7.2.

Constructors

Method |

Fields

- methodValue :: CI Text
- methodOther :: OtherParams

Instances

Eq Method Source # |
Methods (==) :: Method -> Method -> Bool # (/=) :: Method -> Method -> Bool #
Ord Method Source # |
Methods compare :: Method -> Method -> Ordering # (<) :: Method -> Method -> Bool # (<=) :: Method -> Method -> Bool # (>) :: Method -> Method -> Bool # (>=) :: Method -> Method -> Bool # max :: Method -> Method -> Method # min :: Method -> Method -> Method #
Show Method Source # |
Methods showsPrec :: Int -> Method -> ShowS # show :: Method -> String # showList :: [Method] -> ShowS #

data VEvent Source #

Event Component. 3.6.1.

Constructors

VEvent |

Fields

- veDTStamp :: DTStamp
- veUID :: UID
- veClass :: Class

  `def` = `Public`

- veDTStart :: Maybe DTStart
- veCreated :: Maybe Created
- veDescription :: Maybe Description
- veGeo :: Maybe Geo
- veLastMod :: Maybe LastModified
- veLocation :: Maybe Location
- veOrganizer :: Maybe Organizer
- vePriority :: Priority

  `def` = 0

- veSeq :: Sequence

  `def` = 0

- veStatus :: Maybe EventStatus
- veSummary :: Maybe Summary
- veTransp :: TimeTransparency

  `def` = `Opaque`

- veUrl :: Maybe URL
- veRecurId :: Maybe RecurrenceId
- veRRule :: Set RRule
- veDTEndDuration :: Maybe (Either DTEnd DurationProp)
- veAttach :: Set Attachment
- veAttendee :: Set Attendee
- veCategories :: Set Categories
- veComment :: Set Comment
- veContact :: Set Contact
- veExDate :: Set ExDate
- veRStatus :: Set RequestStatus
- veRelated :: Set RelatedTo
- veResources :: Set Resources
- veRDate :: Set RDate
- veAlarms :: Set VAlarm
- veOther :: Set OtherProperty

Instances

Eq VEvent Source # |
Methods (==) :: VEvent -> VEvent -> Bool # (/=) :: VEvent -> VEvent -> Bool #
Ord VEvent Source # |
Methods compare :: VEvent -> VEvent -> Ordering # (<) :: VEvent -> VEvent -> Bool # (<=) :: VEvent -> VEvent -> Bool # (>) :: VEvent -> VEvent -> Bool # (>=) :: VEvent -> VEvent -> Bool # max :: VEvent -> VEvent -> VEvent # min :: VEvent -> VEvent -> VEvent #
Show VEvent Source # |
Methods showsPrec :: Int -> VEvent -> ShowS # show :: VEvent -> String # showList :: [VEvent] -> ShowS #

data VTodo Source #

To-Do Component. 3.6.2

Constructors

VTodo |

Fields

- vtDTStamp :: DTStamp
- vtUID :: UID
- vtClass :: Class

  `def` = `Public`

- vtCompleted :: Maybe Completed
- vtCreated :: Maybe Created
- vtDescription :: Maybe Description
- vtDTStart :: Maybe DTStart
- vtGeo :: Maybe Geo
- vtLastMod :: Maybe LastModified
- vtLocation :: Maybe Location
- vtOrganizer :: Maybe Organizer
- vtPercent :: Maybe PercentComplete
- vtPriority :: Priority

  `def` = 0

- vtRecurId :: Maybe RecurrenceId
- vtSeq :: Sequence

  `def` = 0

- vtStatus :: Maybe TodoStatus
- vtSummary :: Maybe Summary
- vtUrl :: Maybe URL
- vtRRule :: Set RRule
- vtDueDuration :: Maybe (Either Due DurationProp)
- vtAttach :: Set Attachment
- vtAttendee :: Set Attendee
- vtCategories :: Set Categories
- vtComment :: Set Comment
- vtContact :: Set Contact
- vtExDate :: Set ExDate
- vtRStatus :: Set RequestStatus
- vtRelated :: Set RelatedTo
- vtResources :: Set Resources
- vtRDate :: Set RDate
- vtAlarms :: Set VAlarm
- vtOther :: Set OtherProperty

Instances

Eq VTodo Source # |
Methods (==) :: VTodo -> VTodo -> Bool # (/=) :: VTodo -> VTodo -> Bool #
Ord VTodo Source # |
Methods compare :: VTodo -> VTodo -> Ordering # (<) :: VTodo -> VTodo -> Bool # (<=) :: VTodo -> VTodo -> Bool # (>) :: VTodo -> VTodo -> Bool # (>=) :: VTodo -> VTodo -> Bool # max :: VTodo -> VTodo -> VTodo # min :: VTodo -> VTodo -> VTodo #
Show VTodo Source # |
Methods showsPrec :: Int -> VTodo -> ShowS # show :: VTodo -> String # showList :: [VTodo] -> ShowS #

data VJournal Source #

Journal Component. 3.6.3

Constructors

VJournal |

Fields

- vjDTStamp :: DTStamp
- vjUID :: UID
- vjClass :: Class

  `def` = `Public`

- vjCreated :: Maybe Created
- vjDTStart :: Maybe DTStart
- vjLastMod :: Maybe LastModified
- vjOrganizer :: Maybe Organizer
- vjRecurId :: Maybe RecurrenceId
- vjSeq :: Sequence

  `def` = 0

- vjStatus :: Maybe JournalStatus
- vjSummary :: Maybe Summary
- vjUrl :: Maybe URL
- vjRRule :: Set RRule
- vjAttach :: Set Attachment
- vjAttendee :: Set Attendee
- vjCategories :: Set Categories
- vjComment :: Set Comment
- vjContact :: Set Contact
- vjDescription :: Set Description
- vjExDate :: Set ExDate
- vjRelated :: Set RelatedTo
- vjRDate :: Set RDate
- vjRStatus :: Set RequestStatus
- vjOther :: Set OtherProperty

Instances

Eq VJournal Source # |
Methods (==) :: VJournal -> VJournal -> Bool # (/=) :: VJournal -> VJournal -> Bool #
Ord VJournal Source # |
Methods compare :: VJournal -> VJournal -> Ordering # (<) :: VJournal -> VJournal -> Bool # (<=) :: VJournal -> VJournal -> Bool # (>) :: VJournal -> VJournal -> Bool # (>=) :: VJournal -> VJournal -> Bool # max :: VJournal -> VJournal -> VJournal # min :: VJournal -> VJournal -> VJournal #
Show VJournal Source # |
Methods showsPrec :: Int -> VJournal -> ShowS # show :: VJournal -> String # showList :: [VJournal] -> ShowS #

data VFreeBusy Source #

Free/Busy Component. 3.6.4

Constructors

VFreeBusy |

Fields

- vfbDTStamp :: DTStamp
- vfbUID :: UID
- vfbContact :: Maybe Contact
- vfbDTStart :: Maybe DTStart
- vfbDTEnd :: Maybe DTEnd
- vfbOrganizer :: Maybe Organizer
- vfbUrl :: Maybe URL
- vfbAttendee :: Set Attendee
- vfbComment :: Set Comment
- vfbFreeBusy :: Set FreeBusy
- vfbRStatus :: Set RequestStatus
- vfbOther :: Set OtherProperty

Instances

Eq VFreeBusy Source # |
Methods (==) :: VFreeBusy -> VFreeBusy -> Bool # (/=) :: VFreeBusy -> VFreeBusy -> Bool #
Ord VFreeBusy Source # |
Methods compare :: VFreeBusy -> VFreeBusy -> Ordering # (<) :: VFreeBusy -> VFreeBusy -> Bool # (<=) :: VFreeBusy -> VFreeBusy -> Bool # (>) :: VFreeBusy -> VFreeBusy -> Bool # (>=) :: VFreeBusy -> VFreeBusy -> Bool # max :: VFreeBusy -> VFreeBusy -> VFreeBusy # min :: VFreeBusy -> VFreeBusy -> VFreeBusy #
Show VFreeBusy Source # |
Methods showsPrec :: Int -> VFreeBusy -> ShowS # show :: VFreeBusy -> String # showList :: [VFreeBusy] -> ShowS #

data VTimeZone Source #

Time Zone Component. 3.6.5.

Constructors

VTimeZone |

Fields

- vtzId :: TZID
- vtzLastMod :: Maybe LastModified
- vtzUrl :: Maybe TZUrl
- vtzStandardC :: Set TZProp
- vtzDaylightC :: Set TZProp
- vtzOther :: Set OtherProperty

Instances

Eq VTimeZone Source # |
Methods (==) :: VTimeZone -> VTimeZone -> Bool # (/=) :: VTimeZone -> VTimeZone -> Bool #
Ord VTimeZone Source # |
Methods compare :: VTimeZone -> VTimeZone -> Ordering # (<) :: VTimeZone -> VTimeZone -> Bool # (<=) :: VTimeZone -> VTimeZone -> Bool # (>) :: VTimeZone -> VTimeZone -> Bool # (>=) :: VTimeZone -> VTimeZone -> Bool # max :: VTimeZone -> VTimeZone -> VTimeZone # min :: VTimeZone -> VTimeZone -> VTimeZone #
Show VTimeZone Source # |
Methods showsPrec :: Int -> VTimeZone -> ShowS # show :: VTimeZone -> String # showList :: [VTimeZone] -> ShowS #

data TZProp Source #

Time zone property, also 3.6.5.

Constructors

TZProp |

Fields

- tzpDTStart :: DTStart
- tzpTZOffsetTo :: UTCOffset
- tzpTZOffsetFrom :: UTCOffset
- tzpRRule :: Set RRule
- tzpComment :: Set Comment
- tzpRDate :: Set RDate
- tzpTZName :: Set TZName
- tzpOther :: Set OtherProperty

Instances

Eq TZProp Source # |
Methods (==) :: TZProp -> TZProp -> Bool # (/=) :: TZProp -> TZProp -> Bool #
Ord TZProp Source # |
Methods compare :: TZProp -> TZProp -> Ordering # (<) :: TZProp -> TZProp -> Bool # (<=) :: TZProp -> TZProp -> Bool # (>) :: TZProp -> TZProp -> Bool # (>=) :: TZProp -> TZProp -> Bool # max :: TZProp -> TZProp -> TZProp # min :: TZProp -> TZProp -> TZProp #
Show TZProp Source # |
Methods showsPrec :: Int -> TZProp -> ShowS # show :: TZProp -> String # showList :: [TZProp] -> ShowS #

data VAlarm Source #

VAlarm component. 3.6.6.

Constructors

VAlarmAudio |

Fields

- vaTrigger :: Trigger
- vaRepeat :: Repeat

  `def` = 0

- vaDuration :: Maybe DurationProp
- vaAudioAttach :: Maybe Attachment
- vaOther :: Set OtherProperty
- vaActionOther :: OtherParams

VAlarmDisplay |

Fields

- vaDescription :: Description
- vaTrigger :: Trigger
- vaRepeat :: Repeat

  `def` = 0

- vaDuration :: Maybe DurationProp
- vaOther :: Set OtherProperty
- vaActionOther :: OtherParams

VAlarmEmail |

Fields

- vaDescription :: Description
- vaTrigger :: Trigger
- vaSummary :: Summary
- vaAttendee :: Set Attendee
- vaRepeat :: Repeat

  `def` = 0

- vaDuration :: Maybe DurationProp
- vaMailAttach :: Set Attachment
- vaOther :: Set OtherProperty
- vaActionOther :: OtherParams

VAlarmX |

Fields

- vaAction :: CI Text
- vaTrigger :: Trigger
- vaActionOther :: OtherParams
- vaOther :: Set OtherProperty

Instances

Eq VAlarm Source # |
Methods (==) :: VAlarm -> VAlarm -> Bool # (/=) :: VAlarm -> VAlarm -> Bool #
Ord VAlarm Source # |
Methods compare :: VAlarm -> VAlarm -> Ordering # (<) :: VAlarm -> VAlarm -> Bool # (<=) :: VAlarm -> VAlarm -> Bool # (>) :: VAlarm -> VAlarm -> Bool # (>=) :: VAlarm -> VAlarm -> Bool # max :: VAlarm -> VAlarm -> VAlarm # min :: VAlarm -> VAlarm -> VAlarm #
Show VAlarm Source # |
Methods showsPrec :: Int -> VAlarm -> ShowS # show :: VAlarm -> String # showList :: [VAlarm] -> ShowS #

data VOther Source #

Any other component not recognized.

Constructors

VOther |

Fields

- voName :: CI Text
- voProps :: Set OtherProperty

Instances

Eq VOther Source # |
Methods (==) :: VOther -> VOther -> Bool # (/=) :: VOther -> VOther -> Bool #
Ord VOther Source # |
Methods compare :: VOther -> VOther -> Ordering # (<) :: VOther -> VOther -> Bool # (<=) :: VOther -> VOther -> Bool # (>) :: VOther -> VOther -> Bool # (>=) :: VOther -> VOther -> Bool # max :: VOther -> VOther -> VOther # min :: VOther -> VOther -> VOther #
Show VOther Source # |
Methods showsPrec :: Int -> VOther -> ShowS # show :: VOther -> String # showList :: [VOther] -> ShowS #

data Attachment Source #

Attachment. 3.8.1.1.

Constructors

UriAttachment |

Fields

- attachFmtType :: Maybe MIMEType
- attachUri :: URI
- attachOther :: OtherParams

BinaryAttachment |

Fields

- attachFmtType :: Maybe MIMEType
- attachContent :: ByteString
- attachOther :: OtherParams

Instances

Eq Attachment Source # |
Methods (==) :: Attachment -> Attachment -> Bool # (/=) :: Attachment -> Attachment -> Bool #
Ord Attachment Source # |
Methods compare :: Attachment -> Attachment -> Ordering # (<) :: Attachment -> Attachment -> Bool # (<=) :: Attachment -> Attachment -> Bool # (>) :: Attachment -> Attachment -> Bool # (>=) :: Attachment -> Attachment -> Bool # max :: Attachment -> Attachment -> Attachment # min :: Attachment -> Attachment -> Attachment #
Show Attachment Source # |
Methods showsPrec :: Int -> Attachment -> ShowS # show :: Attachment -> String # showList :: [Attachment] -> ShowS #

data Categories Source #

Categories. 3.8.1.2.

Constructors

Categories |

Fields

- categoriesValues :: Set Text
- categoriesLanguage :: Maybe Language
- categoriesOther :: OtherParams

Instances

Eq Categories Source # |
Methods (==) :: Categories -> Categories -> Bool # (/=) :: Categories -> Categories -> Bool #
Ord Categories Source # |
Methods compare :: Categories -> Categories -> Ordering # (<) :: Categories -> Categories -> Bool # (<=) :: Categories -> Categories -> Bool # (>) :: Categories -> Categories -> Bool # (>=) :: Categories -> Categories -> Bool # max :: Categories -> Categories -> Categories # min :: Categories -> Categories -> Categories #
Show Categories Source # |
Methods showsPrec :: Int -> Categories -> ShowS # show :: Categories -> String # showList :: [Categories] -> ShowS #

data Class Source #

Classification. 3.8.1.3.

Constructors

Class |

Fields

- classValue :: ClassValue
- classOther :: OtherParams

Instances

Eq Class Source # |
Methods (==) :: Class -> Class -> Bool # (/=) :: Class -> Class -> Bool #
Ord Class Source # |
Methods compare :: Class -> Class -> Ordering # (<) :: Class -> Class -> Bool # (<=) :: Class -> Class -> Bool # (>) :: Class -> Class -> Bool # (>=) :: Class -> Class -> Bool # max :: Class -> Class -> Class # min :: Class -> Class -> Class #
Show Class Source # |
Methods showsPrec :: Int -> Class -> ShowS # show :: Class -> String # showList :: [Class] -> ShowS #
Default Class Source # |
Methods def :: Class #

data ClassValue Source #

Classification value. 3.8.1.3. Unrecognized ClassValueX MUST be treated as Private.

Constructors

Public |
Private |
Confidential |
ClassValueX (CI Text) |

Instances

Eq ClassValue Source # |
Methods (==) :: ClassValue -> ClassValue -> Bool # (/=) :: ClassValue -> ClassValue -> Bool #
Ord ClassValue Source # |
Methods compare :: ClassValue -> ClassValue -> Ordering # (<) :: ClassValue -> ClassValue -> Bool # (<=) :: ClassValue -> ClassValue -> Bool # (>) :: ClassValue -> ClassValue -> Bool # (>=) :: ClassValue -> ClassValue -> Bool # max :: ClassValue -> ClassValue -> ClassValue # min :: ClassValue -> ClassValue -> ClassValue #
Show ClassValue Source # |
Methods showsPrec :: Int -> ClassValue -> ShowS # show :: ClassValue -> String # showList :: [ClassValue] -> ShowS #
Default ClassValue Source # |
Methods def :: ClassValue #

data Completed Source #

Date-Time Completed. 3.8.2.1.

Constructors

Completed |

Fields

- completedValue :: DateTime
- completedOther :: OtherParams

Instances

Eq Completed Source # |
Methods (==) :: Completed -> Completed -> Bool # (/=) :: Completed -> Completed -> Bool #
Ord Completed Source # |
Methods compare :: Completed -> Completed -> Ordering # (<) :: Completed -> Completed -> Bool # (<=) :: Completed -> Completed -> Bool # (>) :: Completed -> Completed -> Bool # (>=) :: Completed -> Completed -> Bool # max :: Completed -> Completed -> Completed # min :: Completed -> Completed -> Completed #
Show Completed Source # |
Methods showsPrec :: Int -> Completed -> ShowS # show :: Completed -> String # showList :: [Completed] -> ShowS #

data Comment Source #

Comment. 3.8.1.4.

Constructors

Comment |

Fields

- commentValue :: Text
- commentAltRep :: Maybe URI
- commentLanguage :: Maybe Language
- commentOther :: OtherParams

Instances

Eq Comment Source # |
Methods (==) :: Comment -> Comment -> Bool # (/=) :: Comment -> Comment -> Bool #
Ord Comment Source # |
Methods compare :: Comment -> Comment -> Ordering # (<) :: Comment -> Comment -> Bool # (<=) :: Comment -> Comment -> Bool # (>) :: Comment -> Comment -> Bool # (>=) :: Comment -> Comment -> Bool # max :: Comment -> Comment -> Comment # min :: Comment -> Comment -> Comment #
Show Comment Source # |
Methods showsPrec :: Int -> Comment -> ShowS # show :: Comment -> String # showList :: [Comment] -> ShowS #

data Description Source #

Description. 3.8.1.5.

Constructors

Description |

Fields

- descriptionValue :: Text
- descriptionAltRep :: Maybe URI
- descriptionLanguage :: Maybe Language
- descriptionOther :: OtherParams

Instances

Eq Description Source # |
Methods (==) :: Description -> Description -> Bool # (/=) :: Description -> Description -> Bool #
Ord Description Source # |
Methods compare :: Description -> Description -> Ordering # (<) :: Description -> Description -> Bool # (<=) :: Description -> Description -> Bool # (>) :: Description -> Description -> Bool # (>=) :: Description -> Description -> Bool # max :: Description -> Description -> Description # min :: Description -> Description -> Description #
Show Description Source # |
Methods showsPrec :: Int -> Description -> ShowS # show :: Description -> String # showList :: [Description] -> ShowS #

data Geo Source #

Geographic Position. 3.8.1.6.

Constructors

Geo |

Fields

- geoLat :: Float
- geoLong :: Float
- geoOther :: OtherParams

Instances

Eq Geo Source # |
Methods (==) :: Geo -> Geo -> Bool # (/=) :: Geo -> Geo -> Bool #
Ord Geo Source # |
Methods compare :: Geo -> Geo -> Ordering # (<) :: Geo -> Geo -> Bool # (<=) :: Geo -> Geo -> Bool # (>) :: Geo -> Geo -> Bool # (>=) :: Geo -> Geo -> Bool # max :: Geo -> Geo -> Geo # min :: Geo -> Geo -> Geo #
Show Geo Source # |
Methods showsPrec :: Int -> Geo -> ShowS # show :: Geo -> String # showList :: [Geo] -> ShowS #

data Location Source #

Location. 3.8.1.7.

Constructors

Location |

Fields

- locationValue :: Text
- locationAltRep :: Maybe URI
- locationLanguage :: Maybe Language
- locationOther :: OtherParams

Instances

Eq Location Source # |
Methods (==) :: Location -> Location -> Bool # (/=) :: Location -> Location -> Bool #
Ord Location Source # |
Methods compare :: Location -> Location -> Ordering # (<) :: Location -> Location -> Bool # (<=) :: Location -> Location -> Bool # (>) :: Location -> Location -> Bool # (>=) :: Location -> Location -> Bool # max :: Location -> Location -> Location # min :: Location -> Location -> Location #
Show Location Source # |
Methods showsPrec :: Int -> Location -> ShowS # show :: Location -> String # showList :: [Location] -> ShowS #

data PercentComplete Source #

Percent complete. 3.8.1.8.

Constructors

PercentComplete |

Fields

- percentCompleteValue :: Int
- percentCompleteOther :: OtherParams

Instances

Eq PercentComplete Source # |
Methods (==) :: PercentComplete -> PercentComplete -> Bool # (/=) :: PercentComplete -> PercentComplete -> Bool #
Ord PercentComplete Source # |

Methods

compare :: PercentComplete -> PercentComplete -> Ordering #

(<) :: PercentComplete -> PercentComplete -> Bool #

(<=) :: PercentComplete -> PercentComplete -> Bool #

(>) :: PercentComplete -> PercentComplete -> Bool #

(>=) :: PercentComplete -> PercentComplete -> Bool #

max :: PercentComplete -> PercentComplete -> PercentComplete #

min :: PercentComplete -> PercentComplete -> PercentComplete #

Show PercentComplete Source # |
Methods showsPrec :: Int -> PercentComplete -> ShowS # show :: PercentComplete -> String # showList :: [PercentComplete] -> ShowS #

data Priority Source #

Priority. 3.8.1.9.

Constructors

Priority |

Fields

- priorityValue :: Int
- priorityOther :: OtherParams

Instances

Eq Priority Source # |
Methods (==) :: Priority -> Priority -> Bool # (/=) :: Priority -> Priority -> Bool #
Ord Priority Source # |
Methods compare :: Priority -> Priority -> Ordering # (<) :: Priority -> Priority -> Bool # (<=) :: Priority -> Priority -> Bool # (>) :: Priority -> Priority -> Bool # (>=) :: Priority -> Priority -> Bool # max :: Priority -> Priority -> Priority # min :: Priority -> Priority -> Priority #
Show Priority Source # |
Methods showsPrec :: Int -> Priority -> ShowS # show :: Priority -> String # showList :: [Priority] -> ShowS #
Default Priority Source # |
Methods def :: Priority #

data Resources Source #

Resources. 3.8.1.10.

Constructors

Resources |

Fields

- resourcesValue :: Set Text
- resourcesAltRep :: Maybe URI
- resourcesLanguage :: Maybe Language
- resourcesOther :: OtherParams

Instances

Eq Resources Source # |
Methods (==) :: Resources -> Resources -> Bool # (/=) :: Resources -> Resources -> Bool #
Ord Resources Source # |
Methods compare :: Resources -> Resources -> Ordering # (<) :: Resources -> Resources -> Bool # (<=) :: Resources -> Resources -> Bool # (>) :: Resources -> Resources -> Bool # (>=) :: Resources -> Resources -> Bool # max :: Resources -> Resources -> Resources # min :: Resources -> Resources -> Resources #
Show Resources Source # |
Methods showsPrec :: Int -> Resources -> ShowS # show :: Resources -> String # showList :: [Resources] -> ShowS #

data EventStatus Source #

Status, but only for Events. 3.8.1.11.

Constructors

TentativeEvent |

Fields

- eventStatusOther :: OtherParams

ConfirmedEvent |

Fields

- eventStatusOther :: OtherParams

CancelledEvent |

Fields

- eventStatusOther :: OtherParams

Instances

Eq EventStatus Source # |
Methods (==) :: EventStatus -> EventStatus -> Bool # (/=) :: EventStatus -> EventStatus -> Bool #
Ord EventStatus Source # |
Methods compare :: EventStatus -> EventStatus -> Ordering # (<) :: EventStatus -> EventStatus -> Bool # (<=) :: EventStatus -> EventStatus -> Bool # (>) :: EventStatus -> EventStatus -> Bool # (>=) :: EventStatus -> EventStatus -> Bool # max :: EventStatus -> EventStatus -> EventStatus # min :: EventStatus -> EventStatus -> EventStatus #
Show EventStatus Source # |
Methods showsPrec :: Int -> EventStatus -> ShowS # show :: EventStatus -> String # showList :: [EventStatus] -> ShowS #

data TodoStatus Source #

Status, but only for TODOs. 3.8.1.11.

Constructors

TodoNeedsAction |

Fields

- todoStatusOther :: OtherParams

CompletedTodo |

Fields

- todoStatusOther :: OtherParams

InProcessTodo |

Fields

- todoStatusOther :: OtherParams

CancelledTodo |

Fields

- todoStatusOther :: OtherParams

Instances

Eq TodoStatus Source # |
Methods (==) :: TodoStatus -> TodoStatus -> Bool # (/=) :: TodoStatus -> TodoStatus -> Bool #
Ord TodoStatus Source # |
Methods compare :: TodoStatus -> TodoStatus -> Ordering # (<) :: TodoStatus -> TodoStatus -> Bool # (<=) :: TodoStatus -> TodoStatus -> Bool # (>) :: TodoStatus -> TodoStatus -> Bool # (>=) :: TodoStatus -> TodoStatus -> Bool # max :: TodoStatus -> TodoStatus -> TodoStatus # min :: TodoStatus -> TodoStatus -> TodoStatus #
Show TodoStatus Source # |
Methods showsPrec :: Int -> TodoStatus -> ShowS # show :: TodoStatus -> String # showList :: [TodoStatus] -> ShowS #

data JournalStatus Source #

Status, but only for Journals. 3.8.1.11.

Constructors

DraftJournal |

Fields

- journalStatusOther :: OtherParams

FinalJournal |

Fields

- journalStatusOther :: OtherParams

CancelledJournal |

Fields

- journalStatusOther :: OtherParams

Instances

Eq JournalStatus Source # |
Methods (==) :: JournalStatus -> JournalStatus -> Bool # (/=) :: JournalStatus -> JournalStatus -> Bool #
Ord JournalStatus Source # |
Methods compare :: JournalStatus -> JournalStatus -> Ordering # (<) :: JournalStatus -> JournalStatus -> Bool # (<=) :: JournalStatus -> JournalStatus -> Bool # (>) :: JournalStatus -> JournalStatus -> Bool # (>=) :: JournalStatus -> JournalStatus -> Bool # max :: JournalStatus -> JournalStatus -> JournalStatus # min :: JournalStatus -> JournalStatus -> JournalStatus #
Show JournalStatus Source # |
Methods showsPrec :: Int -> JournalStatus -> ShowS # show :: JournalStatus -> String # showList :: [JournalStatus] -> ShowS #

data Summary Source #

Summary. 3.8.1.12.

Constructors

Summary |

Fields

- summaryValue :: Text
- summaryAltRep :: Maybe URI
- summaryLanguage :: Maybe Language
- summaryOther :: OtherParams

Instances

Eq Summary Source # |
Methods (==) :: Summary -> Summary -> Bool # (/=) :: Summary -> Summary -> Bool #
Ord Summary Source # |
Methods compare :: Summary -> Summary -> Ordering # (<) :: Summary -> Summary -> Bool # (<=) :: Summary -> Summary -> Bool # (>) :: Summary -> Summary -> Bool # (>=) :: Summary -> Summary -> Bool # max :: Summary -> Summary -> Summary # min :: Summary -> Summary -> Summary #
Show Summary Source # |
Methods showsPrec :: Int -> Summary -> ShowS # show :: Summary -> String # showList :: [Summary] -> ShowS #

data Date Source #

Date. 3.3.4

Constructors

Date |

Fields

- dateValue :: Day

Instances

Eq Date Source # |
Methods (==) :: Date -> Date -> Bool # (/=) :: Date -> Date -> Bool #
Ord Date Source # |
Methods compare :: Date -> Date -> Ordering # (<) :: Date -> Date -> Bool # (<=) :: Date -> Date -> Bool # (>) :: Date -> Date -> Bool # (>=) :: Date -> Date -> Bool # max :: Date -> Date -> Date # min :: Date -> Date -> Date #
Show Date Source # |
Methods showsPrec :: Int -> Date -> ShowS # show :: Date -> String # showList :: [Date] -> ShowS #

data DateTime Source #

Date-Time value. 3.3.5.

Constructors

FloatingDateTime |

Fields

- dateTimeFloating :: LocalTime

UTCDateTime |

Fields

- dateTimeUTC :: UTCTime

ZonedDateTime |

Fields

- dateTimeFloating :: LocalTime
- dateTimeZone :: Text

Instances

Eq DateTime Source # |
Methods (==) :: DateTime -> DateTime -> Bool # (/=) :: DateTime -> DateTime -> Bool #
Ord DateTime Source # |
Methods compare :: DateTime -> DateTime -> Ordering # (<) :: DateTime -> DateTime -> Bool # (<=) :: DateTime -> DateTime -> Bool # (>) :: DateTime -> DateTime -> Bool # (>=) :: DateTime -> DateTime -> Bool # max :: DateTime -> DateTime -> DateTime # min :: DateTime -> DateTime -> DateTime #
Show DateTime Source # |
Methods showsPrec :: Int -> DateTime -> ShowS # show :: DateTime -> String # showList :: [DateTime] -> ShowS #

data DTEnd Source #

Date-Time End. 3.8.2.2.

Constructors

DTEndDateTime |

Fields

- dtEndDateTimeValue :: DateTime
- dtEndOther :: OtherParams

DTEndDate |

Fields

- dtEndDateValue :: Date
- dtEndOther :: OtherParams

Instances

Eq DTEnd Source # |
Methods (==) :: DTEnd -> DTEnd -> Bool # (/=) :: DTEnd -> DTEnd -> Bool #
Ord DTEnd Source # |
Methods compare :: DTEnd -> DTEnd -> Ordering # (<) :: DTEnd -> DTEnd -> Bool # (<=) :: DTEnd -> DTEnd -> Bool # (>) :: DTEnd -> DTEnd -> Bool # (>=) :: DTEnd -> DTEnd -> Bool # max :: DTEnd -> DTEnd -> DTEnd # min :: DTEnd -> DTEnd -> DTEnd #
Show DTEnd Source # |
Methods showsPrec :: Int -> DTEnd -> ShowS # show :: DTEnd -> String # showList :: [DTEnd] -> ShowS #

data Due Source #

Date-Time Due. 3.8.2.3.

Constructors

DueDateTime |

Fields

- dueDateTimeValue :: DateTime
- dueOther :: OtherParams

DueDate |

Fields

- dueDateValue :: Date
- dueOther :: OtherParams

Instances

Eq Due Source # |
Methods (==) :: Due -> Due -> Bool # (/=) :: Due -> Due -> Bool #
Ord Due Source # |
Methods compare :: Due -> Due -> Ordering # (<) :: Due -> Due -> Bool # (<=) :: Due -> Due -> Bool # (>) :: Due -> Due -> Bool # (>=) :: Due -> Due -> Bool # max :: Due -> Due -> Due # min :: Due -> Due -> Due #
Show Due Source # |
Methods showsPrec :: Int -> Due -> ShowS # show :: Due -> String # showList :: [Due] -> ShowS #

data DTStart Source #

Date-Time Start. 3.8.2.4.

Constructors

DTStartDateTime |

Fields

- dtStartDateTimeValue :: DateTime
- dtStartOther :: OtherParams

DTStartDate |

Fields

- dtStartDateValue :: Date
- dtStartOther :: OtherParams

Instances

Eq DTStart Source # |
Methods (==) :: DTStart -> DTStart -> Bool # (/=) :: DTStart -> DTStart -> Bool #
Ord DTStart Source # |
Methods compare :: DTStart -> DTStart -> Ordering # (<) :: DTStart -> DTStart -> Bool # (<=) :: DTStart -> DTStart -> Bool # (>) :: DTStart -> DTStart -> Bool # (>=) :: DTStart -> DTStart -> Bool # max :: DTStart -> DTStart -> DTStart # min :: DTStart -> DTStart -> DTStart #
Show DTStart Source # |
Methods showsPrec :: Int -> DTStart -> ShowS # show :: DTStart -> String # showList :: [DTStart] -> ShowS #

data Duration Source #

Duration value. 3.3.6.

Constructors

DurationDate |

Fields

- durSign :: Sign

  `def` = `Positive`

- durDay :: Int
- durHour :: Int
- durMinute :: Int
- durSecond :: Int

DurationTime |

Fields

- durSign :: Sign

  `def` = `Positive`

- durHour :: Int
- durMinute :: Int
- durSecond :: Int

DurationWeek |

Fields

- durSign :: Sign

  `def` = `Positive`

- durWeek :: Int

Instances

Eq Duration Source # |
Methods (==) :: Duration -> Duration -> Bool # (/=) :: Duration -> Duration -> Bool #
Ord Duration Source # |
Methods compare :: Duration -> Duration -> Ordering # (<) :: Duration -> Duration -> Bool # (<=) :: Duration -> Duration -> Bool # (>) :: Duration -> Duration -> Bool # (>=) :: Duration -> Duration -> Bool # max :: Duration -> Duration -> Duration # min :: Duration -> Duration -> Duration #
Show Duration Source # |
Methods showsPrec :: Int -> Duration -> ShowS # show :: Duration -> String # showList :: [Duration] -> ShowS #

data Sign Source #

Sign.

Constructors

Positive |
Negative |

Instances

Eq Sign Source # |
Methods (==) :: Sign -> Sign -> Bool # (/=) :: Sign -> Sign -> Bool #
Ord Sign Source # |
Methods compare :: Sign -> Sign -> Ordering # (<) :: Sign -> Sign -> Bool # (<=) :: Sign -> Sign -> Bool # (>) :: Sign -> Sign -> Bool # (>=) :: Sign -> Sign -> Bool # max :: Sign -> Sign -> Sign # min :: Sign -> Sign -> Sign #
Show Sign Source # |
Methods showsPrec :: Int -> Sign -> ShowS # show :: Sign -> String # showList :: [Sign] -> ShowS #
Default Sign Source # |
Methods def :: Sign #

data DurationProp Source #

Duration property. 3.8.2.5.

Constructors

DurationProp |

Fields

- durationValue :: Duration
- durationOther :: OtherParams

Instances

Eq DurationProp Source # |
Methods (==) :: DurationProp -> DurationProp -> Bool # (/=) :: DurationProp -> DurationProp -> Bool #
Ord DurationProp Source # |
Methods compare :: DurationProp -> DurationProp -> Ordering # (<) :: DurationProp -> DurationProp -> Bool # (<=) :: DurationProp -> DurationProp -> Bool # (>) :: DurationProp -> DurationProp -> Bool # (>=) :: DurationProp -> DurationProp -> Bool # max :: DurationProp -> DurationProp -> DurationProp # min :: DurationProp -> DurationProp -> DurationProp #
Show DurationProp Source # |
Methods showsPrec :: Int -> DurationProp -> ShowS # show :: DurationProp -> String # showList :: [DurationProp] -> ShowS #

data FreeBusy Source #

Constructors

FreeBusy |

Fields

- freeBusyType :: FBType
- freeBusyPeriods :: Set UTCPeriod
- freeBusyOther :: OtherParams

Instances

Eq FreeBusy Source # |
Methods (==) :: FreeBusy -> FreeBusy -> Bool # (/=) :: FreeBusy -> FreeBusy -> Bool #
Ord FreeBusy Source # |
Methods compare :: FreeBusy -> FreeBusy -> Ordering # (<) :: FreeBusy -> FreeBusy -> Bool # (<=) :: FreeBusy -> FreeBusy -> Bool # (>) :: FreeBusy -> FreeBusy -> Bool # (>=) :: FreeBusy -> FreeBusy -> Bool # max :: FreeBusy -> FreeBusy -> FreeBusy # min :: FreeBusy -> FreeBusy -> FreeBusy #
Show FreeBusy Source # |
Methods showsPrec :: Int -> FreeBusy -> ShowS # show :: FreeBusy -> String # showList :: [FreeBusy] -> ShowS #

data Period Source #

Period of time. 3.3.9.

Constructors

PeriodDates DateTime DateTime |
PeriodDuration DateTime Duration |

Instances

Eq Period Source # |
Methods (==) :: Period -> Period -> Bool # (/=) :: Period -> Period -> Bool #
Ord Period Source # |
Methods compare :: Period -> Period -> Ordering # (<) :: Period -> Period -> Bool # (<=) :: Period -> Period -> Bool # (>) :: Period -> Period -> Bool # (>=) :: Period -> Period -> Bool # max :: Period -> Period -> Period # min :: Period -> Period -> Period #
Show Period Source # |
Methods showsPrec :: Int -> Period -> ShowS # show :: Period -> String # showList :: [Period] -> ShowS #

data UTCPeriod Source #

Period of time which must be UTC, as in FreeBusy. 3.3.9.

Constructors

UTCPeriodDates UTCTime UTCTime |
UTCPeriodDuration UTCTime Duration |

Instances

Eq UTCPeriod Source # |
Methods (==) :: UTCPeriod -> UTCPeriod -> Bool # (/=) :: UTCPeriod -> UTCPeriod -> Bool #
Ord UTCPeriod Source # |
Methods compare :: UTCPeriod -> UTCPeriod -> Ordering # (<) :: UTCPeriod -> UTCPeriod -> Bool # (<=) :: UTCPeriod -> UTCPeriod -> Bool # (>) :: UTCPeriod -> UTCPeriod -> Bool # (>=) :: UTCPeriod -> UTCPeriod -> Bool # max :: UTCPeriod -> UTCPeriod -> UTCPeriod # min :: UTCPeriod -> UTCPeriod -> UTCPeriod #
Show UTCPeriod Source # |
Methods showsPrec :: Int -> UTCPeriod -> ShowS # show :: UTCPeriod -> String # showList :: [UTCPeriod] -> ShowS #

data FBType Source #

Free/Busy Time Type. 3.2.9.

Unrecognized FBTypeX MUST be treated as Busy.

Constructors

Free |
Busy |
BusyUnavailable |
BusyTentative |
FBTypeX (CI Text) |

Instances

Eq FBType Source # |
Methods (==) :: FBType -> FBType -> Bool # (/=) :: FBType -> FBType -> Bool #
Ord FBType Source # |
Methods compare :: FBType -> FBType -> Ordering # (<) :: FBType -> FBType -> Bool # (<=) :: FBType -> FBType -> Bool # (>) :: FBType -> FBType -> Bool # (>=) :: FBType -> FBType -> Bool # max :: FBType -> FBType -> FBType # min :: FBType -> FBType -> FBType #
Show FBType Source # |
Methods showsPrec :: Int -> FBType -> ShowS # show :: FBType -> String # showList :: [FBType] -> ShowS #
Default FBType Source # |
Methods def :: FBType #

data TimeTransparency Source #

Time Transparency. 3.8.2.7.

Constructors

Opaque |

Fields

- timeTransparencyOther :: OtherParams

Transparent |

Fields

- timeTransparencyOther :: OtherParams

Instances

Eq TimeTransparency Source # |
Methods (==) :: TimeTransparency -> TimeTransparency -> Bool # (/=) :: TimeTransparency -> TimeTransparency -> Bool #
Ord TimeTransparency Source # |

Methods

compare :: TimeTransparency -> TimeTransparency -> Ordering #

(<) :: TimeTransparency -> TimeTransparency -> Bool #

(<=) :: TimeTransparency -> TimeTransparency -> Bool #

(>) :: TimeTransparency -> TimeTransparency -> Bool #

(>=) :: TimeTransparency -> TimeTransparency -> Bool #

max :: TimeTransparency -> TimeTransparency -> TimeTransparency #

min :: TimeTransparency -> TimeTransparency -> TimeTransparency #

Show TimeTransparency Source # |
Methods showsPrec :: Int -> TimeTransparency -> ShowS # show :: TimeTransparency -> String # showList :: [TimeTransparency] -> ShowS #
Default TimeTransparency Source # |
Methods def :: TimeTransparency #

data TZID Source #

Time Zone Identifier. 3.8.3.1.

Constructors

TZID |

Fields

- tzidValue :: Text
- tzidGlobal :: Bool
- tzidOther :: OtherParams

Instances

Eq TZID Source # |
Methods (==) :: TZID -> TZID -> Bool # (/=) :: TZID -> TZID -> Bool #
Ord TZID Source # |
Methods compare :: TZID -> TZID -> Ordering # (<) :: TZID -> TZID -> Bool # (<=) :: TZID -> TZID -> Bool # (>) :: TZID -> TZID -> Bool # (>=) :: TZID -> TZID -> Bool # max :: TZID -> TZID -> TZID # min :: TZID -> TZID -> TZID #
Show TZID Source # |
Methods showsPrec :: Int -> TZID -> ShowS # show :: TZID -> String # showList :: [TZID] -> ShowS #

data TZName Source #

Time Zone Name. 3.8.3.2.

Constructors

TZName |

Fields

- tzNameValue :: Text
- tzNameLanguage :: Maybe Language
- tzNameOther :: OtherParams

Instances

Eq TZName Source # |
Methods (==) :: TZName -> TZName -> Bool # (/=) :: TZName -> TZName -> Bool #
Ord TZName Source # |
Methods compare :: TZName -> TZName -> Ordering # (<) :: TZName -> TZName -> Bool # (<=) :: TZName -> TZName -> Bool # (>) :: TZName -> TZName -> Bool # (>=) :: TZName -> TZName -> Bool # max :: TZName -> TZName -> TZName # min :: TZName -> TZName -> TZName #
Show TZName Source # |
Methods showsPrec :: Int -> TZName -> ShowS # show :: TZName -> String # showList :: [TZName] -> ShowS #

data UTCOffset Source #

UTC Offset. 3.3.14, 3.8.3.4, and 3.8.3.3. (unified-ish)

Constructors

UTCOffset |

Fields

- utcOffsetValue :: Int

  Number of seconds away from UTC

- utcOffsetOther :: OtherParams

Instances

Eq UTCOffset Source # |
Methods (==) :: UTCOffset -> UTCOffset -> Bool # (/=) :: UTCOffset -> UTCOffset -> Bool #
Ord UTCOffset Source # |
Methods compare :: UTCOffset -> UTCOffset -> Ordering # (<) :: UTCOffset -> UTCOffset -> Bool # (<=) :: UTCOffset -> UTCOffset -> Bool # (>) :: UTCOffset -> UTCOffset -> Bool # (>=) :: UTCOffset -> UTCOffset -> Bool # max :: UTCOffset -> UTCOffset -> UTCOffset # min :: UTCOffset -> UTCOffset -> UTCOffset #
Show UTCOffset Source # |
Methods showsPrec :: Int -> UTCOffset -> ShowS # show :: UTCOffset -> String # showList :: [UTCOffset] -> ShowS #

data TZUrl Source #

Time Zone URL. 3.8.3.5.

Constructors

TZUrl |

Fields

- tzUrlValue :: URI
- tzUrlOther :: OtherParams

Instances

Eq TZUrl Source # |
Methods (==) :: TZUrl -> TZUrl -> Bool # (/=) :: TZUrl -> TZUrl -> Bool #
Ord TZUrl Source # |
Methods compare :: TZUrl -> TZUrl -> Ordering # (<) :: TZUrl -> TZUrl -> Bool # (<=) :: TZUrl -> TZUrl -> Bool # (>) :: TZUrl -> TZUrl -> Bool # (>=) :: TZUrl -> TZUrl -> Bool # max :: TZUrl -> TZUrl -> TZUrl # min :: TZUrl -> TZUrl -> TZUrl #
Show TZUrl Source # |
Methods showsPrec :: Int -> TZUrl -> ShowS # show :: TZUrl -> String # showList :: [TZUrl] -> ShowS #

data Attendee Source #

Attendee. 3.8.4.1.

Constructors

Attendee |

Fields

- attendeeValue :: CalAddress
- attendeeCUType :: CUType

  `def` = `Individual`

- attendeeMember :: Set CalAddress
- attendeeRole :: Role

  `def` = `ReqParticipant`

- attendeePartStat :: PartStat

  `def` = `PartStatNeedsAction`

- attendeeRSVP :: Bool
- attendeeDelTo :: Set CalAddress
- attendeeDelFrom :: Set CalAddress
- attendeeSentBy :: Maybe CalAddress
- attendeeCN :: Maybe Text
- attendeeDir :: Maybe URI
- attendeeLanguage :: Maybe Language
- attendeeOther :: OtherParams

Instances

Eq Attendee Source # |
Methods (==) :: Attendee -> Attendee -> Bool # (/=) :: Attendee -> Attendee -> Bool #
Ord Attendee Source # |
Methods compare :: Attendee -> Attendee -> Ordering # (<) :: Attendee -> Attendee -> Bool # (<=) :: Attendee -> Attendee -> Bool # (>) :: Attendee -> Attendee -> Bool # (>=) :: Attendee -> Attendee -> Bool # max :: Attendee -> Attendee -> Attendee # min :: Attendee -> Attendee -> Attendee #
Show Attendee Source # |
Methods showsPrec :: Int -> Attendee -> ShowS # show :: Attendee -> String # showList :: [Attendee] -> ShowS #

data CUType Source #

Calendar User Type. 3.2.3.

Unrecognized CUTypeX MUST be treated as Unknown.

Constructors

Individual |
Group |
Resource |
Room |
Unknown |
CUTypeX (CI Text) |

Instances

Eq CUType Source # |
Methods (==) :: CUType -> CUType -> Bool # (/=) :: CUType -> CUType -> Bool #
Ord CUType Source # |
Methods compare :: CUType -> CUType -> Ordering # (<) :: CUType -> CUType -> Bool # (<=) :: CUType -> CUType -> Bool # (>) :: CUType -> CUType -> Bool # (>=) :: CUType -> CUType -> Bool # max :: CUType -> CUType -> CUType # min :: CUType -> CUType -> CUType #
Show CUType Source # |
Methods showsPrec :: Int -> CUType -> ShowS # show :: CUType -> String # showList :: [CUType] -> ShowS #
Default CUType Source # |
Methods def :: CUType #

data Role Source #

Role. 3.2.16.

Constructors

Chair |
ReqParticipant |
OptParticipant |
NonParticipant |
RoleX (CI Text) |

Instances

Eq Role Source # |
Methods (==) :: Role -> Role -> Bool # (/=) :: Role -> Role -> Bool #
Ord Role Source # |
Methods compare :: Role -> Role -> Ordering # (<) :: Role -> Role -> Bool # (<=) :: Role -> Role -> Bool # (>) :: Role -> Role -> Bool # (>=) :: Role -> Role -> Bool # max :: Role -> Role -> Role # min :: Role -> Role -> Role #
Show Role Source # |
Methods showsPrec :: Int -> Role -> ShowS # show :: Role -> String # showList :: [Role] -> ShowS #
Default Role Source # |
Methods def :: Role #

data PartStat Source #

Participation Status. 3.2.12.

Constructors

PartStatNeedsAction |
Accepted |
Declined |
Tentative |
Delegated |
PartStatCompleted |
InProcess |
PartStatX (CI Text) |

Instances

Eq PartStat Source # |
Methods (==) :: PartStat -> PartStat -> Bool # (/=) :: PartStat -> PartStat -> Bool #
Ord PartStat Source # |
Methods compare :: PartStat -> PartStat -> Ordering # (<) :: PartStat -> PartStat -> Bool # (<=) :: PartStat -> PartStat -> Bool # (>) :: PartStat -> PartStat -> Bool # (>=) :: PartStat -> PartStat -> Bool # max :: PartStat -> PartStat -> PartStat # min :: PartStat -> PartStat -> PartStat #
Show PartStat Source # |
Methods showsPrec :: Int -> PartStat -> ShowS # show :: PartStat -> String # showList :: [PartStat] -> ShowS #
Default PartStat Source # |
Methods def :: PartStat #

data Contact Source #

Contact. 3.8.4.2.

Constructors

Contact |

Fields

- contactValue :: Text
- contactAltRep :: Maybe URI
- contactLanguage :: Maybe Language
- contactOther :: OtherParams

Instances

Eq Contact Source # |
Methods (==) :: Contact -> Contact -> Bool # (/=) :: Contact -> Contact -> Bool #
Ord Contact Source # |
Methods compare :: Contact -> Contact -> Ordering # (<) :: Contact -> Contact -> Bool # (<=) :: Contact -> Contact -> Bool # (>) :: Contact -> Contact -> Bool # (>=) :: Contact -> Contact -> Bool # max :: Contact -> Contact -> Contact # min :: Contact -> Contact -> Contact #
Show Contact Source # |
Methods showsPrec :: Int -> Contact -> ShowS # show :: Contact -> String # showList :: [Contact] -> ShowS #

data Organizer Source #

Organizer. 3.8.4.3.

TODO: CAL-ADDRESS-related properties.

Constructors

Organizer |

Fields

- organizerValue :: CalAddress
- organizerCN :: Maybe Text
- organizerDir :: Maybe URI
- organizerSentBy :: Maybe CalAddress
- organizerLanguage :: Maybe Language
- organizerOther :: OtherParams

Instances

Eq Organizer Source # |
Methods (==) :: Organizer -> Organizer -> Bool # (/=) :: Organizer -> Organizer -> Bool #
Ord Organizer Source # |
Methods compare :: Organizer -> Organizer -> Ordering # (<) :: Organizer -> Organizer -> Bool # (<=) :: Organizer -> Organizer -> Bool # (>) :: Organizer -> Organizer -> Bool # (>=) :: Organizer -> Organizer -> Bool # max :: Organizer -> Organizer -> Organizer # min :: Organizer -> Organizer -> Organizer #
Show Organizer Source # |
Methods showsPrec :: Int -> Organizer -> ShowS # show :: Organizer -> String # showList :: [Organizer] -> ShowS #

data RecurrenceId Source #

Recurrence ID. 3.8.4.4.

Constructors

RecurrenceIdDate |

Fields

- recurrenceIdDate :: Date
- recurrenceIdRange :: Maybe Range
- recurrenceIdOther :: OtherParams

RecurrenceIdDateTime |

Fields

- recurrenceIdDateTime :: DateTime
- recurrenceIdRange :: Maybe Range
- recurrenceIdOther :: OtherParams

Instances

Eq RecurrenceId Source # |
Methods (==) :: RecurrenceId -> RecurrenceId -> Bool # (/=) :: RecurrenceId -> RecurrenceId -> Bool #
Ord RecurrenceId Source # |
Methods compare :: RecurrenceId -> RecurrenceId -> Ordering # (<) :: RecurrenceId -> RecurrenceId -> Bool # (<=) :: RecurrenceId -> RecurrenceId -> Bool # (>) :: RecurrenceId -> RecurrenceId -> Bool # (>=) :: RecurrenceId -> RecurrenceId -> Bool # max :: RecurrenceId -> RecurrenceId -> RecurrenceId # min :: RecurrenceId -> RecurrenceId -> RecurrenceId #
Show RecurrenceId Source # |
Methods showsPrec :: Int -> RecurrenceId -> ShowS # show :: RecurrenceId -> String # showList :: [RecurrenceId] -> ShowS #

data Range Source #

Recurrence Identifier Range. 3.2.13

Constructors

ThisAndFuture |
ThisAndPrior |

Instances

Eq Range Source # |
Methods (==) :: Range -> Range -> Bool # (/=) :: Range -> Range -> Bool #
Ord Range Source # |
Methods compare :: Range -> Range -> Ordering # (<) :: Range -> Range -> Bool # (<=) :: Range -> Range -> Bool # (>) :: Range -> Range -> Bool # (>=) :: Range -> Range -> Bool # max :: Range -> Range -> Range # min :: Range -> Range -> Range #
Show Range Source # |
Methods showsPrec :: Int -> Range -> ShowS # show :: Range -> String # showList :: [Range] -> ShowS #

data RelatedTo Source #

Related To. 3.8.4.5.

Constructors

RelatedTo |

Fields

- relatedToValue :: Text
- relatedToType :: RelationshipType
- relatedToOther :: OtherParams

Instances

Eq RelatedTo Source # |
Methods (==) :: RelatedTo -> RelatedTo -> Bool # (/=) :: RelatedTo -> RelatedTo -> Bool #
Ord RelatedTo Source # |
Methods compare :: RelatedTo -> RelatedTo -> Ordering # (<) :: RelatedTo -> RelatedTo -> Bool # (<=) :: RelatedTo -> RelatedTo -> Bool # (>) :: RelatedTo -> RelatedTo -> Bool # (>=) :: RelatedTo -> RelatedTo -> Bool # max :: RelatedTo -> RelatedTo -> RelatedTo # min :: RelatedTo -> RelatedTo -> RelatedTo #
Show RelatedTo Source # |
Methods showsPrec :: Int -> RelatedTo -> ShowS # show :: RelatedTo -> String # showList :: [RelatedTo] -> ShowS #

data RelationshipType Source #

Relationship Type. 3.2.15.

Unrecognized RelationshipTypeX values MUST be treated as Parent.

Constructors

Parent |
Child |
Sibling |
RelationshipTypeX (CI Text) |

Instances

Eq RelationshipType Source # |
Methods (==) :: RelationshipType -> RelationshipType -> Bool # (/=) :: RelationshipType -> RelationshipType -> Bool #
Ord RelationshipType Source # |

Methods

compare :: RelationshipType -> RelationshipType -> Ordering #

(<) :: RelationshipType -> RelationshipType -> Bool #

(<=) :: RelationshipType -> RelationshipType -> Bool #

(>) :: RelationshipType -> RelationshipType -> Bool #

(>=) :: RelationshipType -> RelationshipType -> Bool #

max :: RelationshipType -> RelationshipType -> RelationshipType #

min :: RelationshipType -> RelationshipType -> RelationshipType #

Show RelationshipType Source # |
Methods showsPrec :: Int -> RelationshipType -> ShowS # show :: RelationshipType -> String # showList :: [RelationshipType] -> ShowS #
Default RelationshipType Source # |
Methods def :: RelationshipType #

data URL Source #

Uniform Resource Locator. 3.8.4.6.

Constructors

URL |

Fields

- urlValue :: URI
- urlOther :: OtherParams

Instances

Eq URL Source # |
Methods (==) :: URL -> URL -> Bool # (/=) :: URL -> URL -> Bool #
Ord URL Source # |
Methods compare :: URL -> URL -> Ordering # (<) :: URL -> URL -> Bool # (<=) :: URL -> URL -> Bool # (>) :: URL -> URL -> Bool # (>=) :: URL -> URL -> Bool # max :: URL -> URL -> URL # min :: URL -> URL -> URL #
Show URL Source # |
Methods showsPrec :: Int -> URL -> ShowS # show :: URL -> String # showList :: [URL] -> ShowS #

data UID Source #

Unique Identifier. 3.8.4.7.

Constructors

UID |

Fields

- uidValue :: Text
- uidOther :: OtherParams

Instances

Eq UID Source # |
Methods (==) :: UID -> UID -> Bool # (/=) :: UID -> UID -> Bool #
Ord UID Source # |
Methods compare :: UID -> UID -> Ordering # (<) :: UID -> UID -> Bool # (<=) :: UID -> UID -> Bool # (>) :: UID -> UID -> Bool # (>=) :: UID -> UID -> Bool # max :: UID -> UID -> UID # min :: UID -> UID -> UID #
Show UID Source # |
Methods showsPrec :: Int -> UID -> ShowS # show :: UID -> String # showList :: [UID] -> ShowS #

data ExDate Source #

Exception Date-Times. 3.8.5.1.

Constructors

ExDates |

Fields

- exDates :: Set Date
- exDateOther :: OtherParams

ExDateTimes |

Fields

- exDateTimes :: Set DateTime
- exDateOther :: OtherParams

Instances

Eq ExDate Source # |
Methods (==) :: ExDate -> ExDate -> Bool # (/=) :: ExDate -> ExDate -> Bool #
Ord ExDate Source # |
Methods compare :: ExDate -> ExDate -> Ordering # (<) :: ExDate -> ExDate -> Bool # (<=) :: ExDate -> ExDate -> Bool # (>) :: ExDate -> ExDate -> Bool # (>=) :: ExDate -> ExDate -> Bool # max :: ExDate -> ExDate -> ExDate # min :: ExDate -> ExDate -> ExDate #
Show ExDate Source # |
Methods showsPrec :: Int -> ExDate -> ShowS # show :: ExDate -> String # showList :: [ExDate] -> ShowS #

data RDate Source #

Recurrence Date-Times. 3.8.5.2.

Constructors

RDateDates |

Fields

- rDateDates :: Set Date
- rDateOther :: OtherParams

RDateDateTimes |

Fields

- rDateDateTimes :: Set DateTime
- rDateOther :: OtherParams

RDatePeriods |

Fields

- rDatePeriods :: Set Period
- rDateOther :: OtherParams

Instances

Eq RDate Source # |
Methods (==) :: RDate -> RDate -> Bool # (/=) :: RDate -> RDate -> Bool #
Ord RDate Source # |
Methods compare :: RDate -> RDate -> Ordering # (<) :: RDate -> RDate -> Bool # (<=) :: RDate -> RDate -> Bool # (>) :: RDate -> RDate -> Bool # (>=) :: RDate -> RDate -> Bool # max :: RDate -> RDate -> RDate # min :: RDate -> RDate -> RDate #
Show RDate Source # |
Methods showsPrec :: Int -> RDate -> ShowS # show :: RDate -> String # showList :: [RDate] -> ShowS #

data Frequency Source #

Frequency in recurrences. 3.3.10.

Constructors

Secondly |
Minutely |
Hourly |
Daily |
Weekly |
Monthly |
Yearly |

Instances

Eq Frequency Source # |
Methods (==) :: Frequency -> Frequency -> Bool # (/=) :: Frequency -> Frequency -> Bool #
Ord Frequency Source # |
Methods compare :: Frequency -> Frequency -> Ordering # (<) :: Frequency -> Frequency -> Bool # (<=) :: Frequency -> Frequency -> Bool # (>) :: Frequency -> Frequency -> Bool # (>=) :: Frequency -> Frequency -> Bool # max :: Frequency -> Frequency -> Frequency # min :: Frequency -> Frequency -> Frequency #
Show Frequency Source # |
Methods showsPrec :: Int -> Frequency -> ShowS # show :: Frequency -> String # showList :: [Frequency] -> ShowS #

data Weekday Source #

Weekday, in recurrences. 3.3.10.

Constructors

Sunday |
Monday |
Tuesday |
Wednesday |
Thursday |
Friday |
Saturday |

Instances

Bounded Weekday Source # |
Methods minBound :: Weekday # maxBound :: Weekday #
Enum Weekday Source # |
Methods succ :: Weekday -> Weekday # pred :: Weekday -> Weekday # toEnum :: Int -> Weekday # fromEnum :: Weekday -> Int # enumFrom :: Weekday -> [Weekday] # enumFromThen :: Weekday -> Weekday -> [Weekday] # enumFromTo :: Weekday -> Weekday -> [Weekday] # enumFromThenTo :: Weekday -> Weekday -> Weekday -> [Weekday] #
Eq Weekday Source # |
Methods (==) :: Weekday -> Weekday -> Bool # (/=) :: Weekday -> Weekday -> Bool #
Ord Weekday Source # |
Methods compare :: Weekday -> Weekday -> Ordering # (<) :: Weekday -> Weekday -> Bool # (<=) :: Weekday -> Weekday -> Bool # (>) :: Weekday -> Weekday -> Bool # (>=) :: Weekday -> Weekday -> Bool # max :: Weekday -> Weekday -> Weekday # min :: Weekday -> Weekday -> Weekday #
Show Weekday Source # |
Methods showsPrec :: Int -> Weekday -> ShowS # show :: Weekday -> String # showList :: [Weekday] -> ShowS #

data Recur Source #

Recur value. 3.3.10.

Constructors

Recur |

Fields

- recurFreq :: Frequency
- recurUntilCount :: Maybe (Either (Either Date DateTime) Int)
- recurInterval :: Int
- recurBySecond :: [Int]
- recurByMinute :: [Int]
- recurByHour :: [Int]
- recurByDay :: [Either (Int, Weekday) Weekday]
- recurByMonthDay :: [Int]
- recurByYearDay :: [Int]
- recurByWeekNo :: [Int]
- recurByMonth :: [Int]
- recurBySetPos :: [Int]
- recurWkSt :: Weekday

Instances

Eq Recur Source # |
Methods (==) :: Recur -> Recur -> Bool # (/=) :: Recur -> Recur -> Bool #
Ord Recur Source # |
Methods compare :: Recur -> Recur -> Ordering # (<) :: Recur -> Recur -> Bool # (<=) :: Recur -> Recur -> Bool # (>) :: Recur -> Recur -> Bool # (>=) :: Recur -> Recur -> Bool # max :: Recur -> Recur -> Recur # min :: Recur -> Recur -> Recur #
Show Recur Source # |
Methods showsPrec :: Int -> Recur -> ShowS # show :: Recur -> String # showList :: [Recur] -> ShowS #

data RRule Source #

Recurrence Rule. 3.8.5.3.

Constructors

RRule |

Fields

- rRuleValue :: Recur
- rRuleOther :: OtherParams

Instances

Eq RRule Source # |
Methods (==) :: RRule -> RRule -> Bool # (/=) :: RRule -> RRule -> Bool #
Ord RRule Source # |
Methods compare :: RRule -> RRule -> Ordering # (<) :: RRule -> RRule -> Bool # (<=) :: RRule -> RRule -> Bool # (>) :: RRule -> RRule -> Bool # (>=) :: RRule -> RRule -> Bool # max :: RRule -> RRule -> RRule # min :: RRule -> RRule -> RRule #
Show RRule Source # |
Methods showsPrec :: Int -> RRule -> ShowS # show :: RRule -> String # showList :: [RRule] -> ShowS #

data Repeat Source #

Repeat count. 3.8.6.2.

Constructors

Repeat |

Fields

- repeatValue :: Integer
- repeatOther :: OtherParams

Instances

Eq Repeat Source # |
Methods (==) :: Repeat -> Repeat -> Bool # (/=) :: Repeat -> Repeat -> Bool #
Ord Repeat Source # |
Methods compare :: Repeat -> Repeat -> Ordering # (<) :: Repeat -> Repeat -> Bool # (<=) :: Repeat -> Repeat -> Bool # (>) :: Repeat -> Repeat -> Bool # (>=) :: Repeat -> Repeat -> Bool # max :: Repeat -> Repeat -> Repeat # min :: Repeat -> Repeat -> Repeat #
Show Repeat Source # |
Methods showsPrec :: Int -> Repeat -> ShowS # show :: Repeat -> String # showList :: [Repeat] -> ShowS #
Default Repeat Source # |
Methods def :: Repeat #

data AlarmTriggerRelationship Source #

Alarm Trigger Relationship. 3.2.14.

Constructors

Start |
End |

Instances

Eq AlarmTriggerRelationship Source # |
Methods (==) :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> Bool # (/=) :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> Bool #
Ord AlarmTriggerRelationship Source # |

Methods

compare :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> Ordering #

(<) :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> Bool #

(<=) :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> Bool #

(>) :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> Bool #

(>=) :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> Bool #

max :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> AlarmTriggerRelationship #

min :: AlarmTriggerRelationship -> AlarmTriggerRelationship -> AlarmTriggerRelationship #

Show AlarmTriggerRelationship Source # |
Methods showsPrec :: Int -> AlarmTriggerRelationship -> ShowS # show :: AlarmTriggerRelationship -> String # showList :: [AlarmTriggerRelationship] -> ShowS #
Default AlarmTriggerRelationship Source # |
Methods def :: AlarmTriggerRelationship #

data Trigger Source #

Trigger. 3.8.6.3.

Constructors

TriggerDuration |

Fields

- triggerDuration :: Duration
- triggerRelated :: AlarmTriggerRelationship

  `def` = `Start`

- triggerOther :: OtherParams

TriggerDateTime |

Fields

- triggerDateTime :: UTCTime
- triggerOther :: OtherParams

Instances

Eq Trigger Source # |
Methods (==) :: Trigger -> Trigger -> Bool # (/=) :: Trigger -> Trigger -> Bool #
Ord Trigger Source # |
Methods compare :: Trigger -> Trigger -> Ordering # (<) :: Trigger -> Trigger -> Bool # (<=) :: Trigger -> Trigger -> Bool # (>) :: Trigger -> Trigger -> Bool # (>=) :: Trigger -> Trigger -> Bool # max :: Trigger -> Trigger -> Trigger # min :: Trigger -> Trigger -> Trigger #
Show Trigger Source # |
Methods showsPrec :: Int -> Trigger -> ShowS # show :: Trigger -> String # showList :: [Trigger] -> ShowS #

data Created Source #

Date-Time Created. 3.8.7.1.

Constructors

Created |

Fields

- createdValue :: UTCTime
- createdOther :: OtherParams

Instances

Eq Created Source # |
Methods (==) :: Created -> Created -> Bool # (/=) :: Created -> Created -> Bool #
Ord Created Source # |
Methods compare :: Created -> Created -> Ordering # (<) :: Created -> Created -> Bool # (<=) :: Created -> Created -> Bool # (>) :: Created -> Created -> Bool # (>=) :: Created -> Created -> Bool # max :: Created -> Created -> Created # min :: Created -> Created -> Created #
Show Created Source # |
Methods showsPrec :: Int -> Created -> ShowS # show :: Created -> String # showList :: [Created] -> ShowS #

data DTStamp Source #

Date-Time Stamp. 3.8.7.2.

Constructors

DTStamp |

Fields

- dtStampValue :: UTCTime
- dtStampOther :: OtherParams

Instances

Eq DTStamp Source # |
Methods (==) :: DTStamp -> DTStamp -> Bool # (/=) :: DTStamp -> DTStamp -> Bool #
Ord DTStamp Source # |
Methods compare :: DTStamp -> DTStamp -> Ordering # (<) :: DTStamp -> DTStamp -> Bool # (<=) :: DTStamp -> DTStamp -> Bool # (>) :: DTStamp -> DTStamp -> Bool # (>=) :: DTStamp -> DTStamp -> Bool # max :: DTStamp -> DTStamp -> DTStamp # min :: DTStamp -> DTStamp -> DTStamp #
Show DTStamp Source # |
Methods showsPrec :: Int -> DTStamp -> ShowS # show :: DTStamp -> String # showList :: [DTStamp] -> ShowS #

data LastModified Source #

Last Modified. 3.8.7.3.

Constructors

LastModified |

Fields

- lastModifiedValue :: UTCTime
- lastModifiedOther :: OtherParams

Instances

Eq LastModified Source # |
Methods (==) :: LastModified -> LastModified -> Bool # (/=) :: LastModified -> LastModified -> Bool #
Ord LastModified Source # |
Methods compare :: LastModified -> LastModified -> Ordering # (<) :: LastModified -> LastModified -> Bool # (<=) :: LastModified -> LastModified -> Bool # (>) :: LastModified -> LastModified -> Bool # (>=) :: LastModified -> LastModified -> Bool # max :: LastModified -> LastModified -> LastModified # min :: LastModified -> LastModified -> LastModified #
Show LastModified Source # |
Methods showsPrec :: Int -> LastModified -> ShowS # show :: LastModified -> String # showList :: [LastModified] -> ShowS #

data Sequence Source #

Sequence number. 3.8.7.4.

Constructors

Sequence |

Fields

- sequenceValue :: Integer
- sequenceOther :: OtherParams

Instances

Eq Sequence Source # |
Methods (==) :: Sequence -> Sequence -> Bool # (/=) :: Sequence -> Sequence -> Bool #
Ord Sequence Source # |
Methods compare :: Sequence -> Sequence -> Ordering # (<) :: Sequence -> Sequence -> Bool # (<=) :: Sequence -> Sequence -> Bool # (>) :: Sequence -> Sequence -> Bool # (>=) :: Sequence -> Sequence -> Bool # max :: Sequence -> Sequence -> Sequence # min :: Sequence -> Sequence -> Sequence #
Show Sequence Source # |
Methods showsPrec :: Int -> Sequence -> ShowS # show :: Sequence -> String # showList :: [Sequence] -> ShowS #
Default Sequence Source # |
Methods def :: Sequence #

data RequestStatus Source #

Request Status. 3.8.8.3.

Constructors

RequestStatus |

Fields

- requestStatusCode :: [Int]
- requestStatusDesc :: Text
- requestStatusLanguage :: Maybe Language
- requestStatusExt :: Maybe Text
- requestStatusOther :: OtherParams

Instances

Eq RequestStatus Source # |
Methods (==) :: RequestStatus -> RequestStatus -> Bool # (/=) :: RequestStatus -> RequestStatus -> Bool #
Ord RequestStatus Source # |
Methods compare :: RequestStatus -> RequestStatus -> Ordering # (<) :: RequestStatus -> RequestStatus -> Bool # (<=) :: RequestStatus -> RequestStatus -> Bool # (>) :: RequestStatus -> RequestStatus -> Bool # (>=) :: RequestStatus -> RequestStatus -> Bool # max :: RequestStatus -> RequestStatus -> RequestStatus # min :: RequestStatus -> RequestStatus -> RequestStatus #
Show RequestStatus Source # |
Methods showsPrec :: Int -> RequestStatus -> ShowS # show :: RequestStatus -> String # showList :: [RequestStatus] -> ShowS #

data OtherProperty Source #

Any other property.

Constructors

OtherProperty |

Fields

- otherName :: CI Text
- otherValue :: ByteString
- otherParams :: OtherParams

Instances

Eq OtherProperty Source # |
Methods (==) :: OtherProperty -> OtherProperty -> Bool # (/=) :: OtherProperty -> OtherProperty -> Bool #
Ord OtherProperty Source # |
Methods compare :: OtherProperty -> OtherProperty -> Ordering # (<) :: OtherProperty -> OtherProperty -> Bool # (<=) :: OtherProperty -> OtherProperty -> Bool # (>) :: OtherProperty -> OtherProperty -> Bool # (>=) :: OtherProperty -> OtherProperty -> Bool # max :: OtherProperty -> OtherProperty -> OtherProperty # min :: OtherProperty -> OtherProperty -> OtherProperty #
Show OtherProperty Source # |
Methods showsPrec :: Int -> OtherProperty -> ShowS # show :: OtherProperty -> String # showList :: [OtherProperty] -> ShowS #